#include<iostream>
#include<fstream>
#include<cstring>
#include <stdlib.h>
#include<math.h>
using namespace std;
int UCount,CCount;
char inputFileName[20],outputFileName[20];
int F[100][100]={0},W[100][100]={0},L[100][100]={0},WFRS[100][100]={0};
ofstream ofs;
/*method for copying string from a substring from defined indices*/
void copySubString(char *str1,char *str2,int start,int end){
    int i,j=0;
    for(i = start; i <= end; i++,j++)
    {
        str2[j]=str1[i];
    }
    str2[j]=0;
}
/*method calculating reflexive of a matrix*/
void reflexive(int matrix[100][100]){
    for(int i = 0;i < CCount;i++)
    {
        for(int j = 0;j < CCount;j++)
        {
            matrix[i][i]=1;
        }
    }
}
/*method calculating symmetric of a matrix*/
void symmetric(int matrix[100][100]){
    for(int i = 0;i < CCount;i++)
    {
        for(int j = 0;j < CCount;j++)
        {
            if(matrix[i][j]==1)
            matrix[j][i]=1;
        }
    }
}
/*method calculating product of Frs and W matrices*/
void calculateWFRS(int F[100][100],int W[100][100],int WFRS[100][100]){
    for(int i = 0;i < UCount;i++)
    {
        for(int j = 0;j <UCount;j++)
        {
            if(j!=i&&F[i][j]==1){
                for(int k = 0;k <CCount;k++){
                    WFRS[i][k]=WFRS[i][k]||W[i][k]||W[j][k];
                }
            }
        }
    }
}
/*method calculating union of WFRS and L matrices*/
void calculateLFW(int L[100][100],int WFRS[100][100]){
    for(int i = 0;i < UCount;i++){
        for(int j = 0;j <CCount;j++){
                    WFRS[i][j]=WFRS[i][j]||L[i][j];
        }
    }
}

/*method for generating the sets using binary mapping */
void generateSet(int val,int sets[]){
    for(int i = 0; i <UCount ; i++){
        sets[i]=0;
    }
    for(int i = UCount; i >=0; i--){
        if(val-pow(2,i)>=0){
            val=val-pow(2,i);
            sets[i]=1;
        }
    } 
}

/*method for performing the and operation on two sets*/
void AND(int set1[],int set2[]){
    for(int i = 0; i <CCount; i++){
        set1[i]=set1[i]&&set2[i];
    } 
}

/*method for performing the or operation on two sets*/
void OR(int set1[],int set2[]){
    for(int i = 0; i <CCount; i++){
        set1[i]=set1[i]||set2[i];
    } 
}

/*method to remove one from first set according the second set*/
void RemoveOne(int set1[],int set2[]){
    for(int i = 0; i <CCount; i++){
        if(set2[i]==1){
        set1[i]=0;
        }
    } 
}

/*method for initializing the set*/
void initialize(int set1[],int val){
    for(int i = 0; i <CCount; i++){
        set1[i]=val;
    } 
}

/*method for printing sets of user*/
void printSet(int set[]){
    int val=0,flag=0;
    cout<<"{";
    ofs<<"{";
    for(int i = 0; i <UCount; i++){
        if(set[i]==1){
            val+=pow(2,i);
            if(flag){
            cout<<",";
            ofs<<",";
            }
            flag=1;
            cout<<i+1;
            ofs<<i+1;
        }
    } 
    cout<<"}\t";
    ofs<<"}\t";
}

/*method for printing the dissimilar sets of user*/
void printReverseSet(int set[]){
    int val=0,flag=0;
    cout<<"{";
    ofs<<"{";
    for(int i = 0; i <UCount; i++){
        if(set[i]==0){
            val+=pow(2,i);
            if(flag){
            cout<<",";
            ofs<<",";
            }
            flag=1;
            cout<<i+1;
            ofs<<i+1;
        }
    } 
    cout<<"}";
    ofs<<"}\t";
}

/*method for calculating the dissimar sets of user*/
void calculateDissimilarSets(int sets[],int reverseSets[]){
    int sumA=0,sumB=0,setsize=0;  
    ofs.open(outputFileName,std::ios_base::out|std::ios_base::app);
    for(int i = 0;i < UCount;i++){
            if(reverseSets[i]==0){
                sumA+=i+1;
            }
            if(sets[i]==1){
                sumB+=i+1;
            }
            else{
                setsize++;
            }
        }
    if(sumA!=sumB){
        if(setsize>=2){
        printSet(reverseSets);
        int i=0;
        for(;i<=UCount;i++){
            if(sets[i]==0){
                sets[i]=1;
                break;
            }
        }
        printReverseSet(sets);
        sets[i]=0;
        cout<<endl;
        ofs<<"\n";
        ofs.seekp(0);
        printSet(reverseSets);
        for(i++;i<=UCount;i++){
                if(sets[i]==0){
                    sets[i]=1;
                    break;
                }
            }
         printReverseSet(sets);
         sets[i]=0;
         cout<<endl;
         ofs<<"\n";
        }
        printSet(reverseSets);
        printReverseSet(sets);
        cout<<endl;
        ofs<<"\n";
    }
    ofs.close();
}

/*method for checking empty set */
int checkEmptySet(int reverseSets[]){
    int val=0;
    for(int i = 0; i <UCount; i++){
        val+=reverseSets[i];
    } 
    return val==UCount;
}

/*method for checking all values of 2 sets are equal or not */
int checkEqual(int set1[],int set2[]){
    for(int i = 0; i <UCount; i++){
        if(set1[i]!=set2[i]){
            return 0;
        }
    } 
    return 1;
}

/*method for checking all values in set are 1 or not */
int checkAllOnes(int set1[]){
    for(int i = 0; i <UCount; i++){
        if(set1[i]!=1){
            return 0;
        }
    } 
    return 1;
}

/*method for reading inputs from file*/
void readFromInputfile(){
    int flag=0;
    ifstream inputFileStream;
    inputFileStream.open(inputFileName);
    if (inputFileStream.is_open()) {
        char str[255]="";
        char temp[5];
        int row,col;
        while(inputFileStream) {
            if(flag==0){
            inputFileStream.getline(str, 255); 
            } 
            if(inputFileStream) {
                if(!strcmp(str,"#U")){
                    inputFileStream.getline(str, 255);
                    UCount=atoi(str);
                }
                else if(!strcmp(str,"#C")){
                    inputFileStream.getline(str, 255);
                    CCount=atoi(str);
                }  
                else if(!strcmp(str,"#F")||flag==1){
                    inputFileStream.getline(str, 255);
                    if(!strcmp(str,"#W")){
                        flag=2;
                    }
                    else{
                    for(int i = 0;i < strlen(str);i++)
                    {
                        if(str[i]==' '){
                            copySubString(str,temp,0,i-1);
                            row=atoi(temp);
                            copySubString(str,temp,i+1,strlen(str));
                            col=atoi(temp);
                        }
                    }
                    F[row-1][col-1]=1;
                    flag=1;
                    }
                } 
                else if(!strcmp(str,"#W")||flag==2){
                    inputFileStream.getline(str, 255);
                    if(!strcmp(str,"#L")){
                        flag=3;
                    }
                    else{
                    for(int i = 0;i < strlen(str);i++)
                    {
                        if(str[i]==' '){
                            copySubString(str,temp,0,i-1);
                            row=atoi(temp);
                            copySubString(str,temp,i+1,strlen(str));
                            col=atoi(temp);
                        }
                    }
                    W[row-1][col-1]=1;
                    flag=2;
                    }
                } 
                else if(!strcmp(str,"#L")||flag==3){
                    inputFileStream.getline(str, 255);
                    if(inputFileStream) {
                    for(int i = 0;i < strlen(str);i++)
                    {
                        if(str[i]==' '){
                            copySubString(str,temp,0,i-1);
                            row=atoi(temp);
                            copySubString(str,temp,i+1,strlen(str));
                            col=atoi(temp);
                        }
                    }
                    L[row-1][col-1]=1;
                    }
                } 
            }
        }
    }
    inputFileStream.close();
}

/* main function for implementaion of the algorithm*/ 
int main(int argc,char **argv)
{
    int sets[100]={0},reverseSets[100]={0};
    int leftSet[100]={0},WrightSet[100]={0};
    copySubString(argv[1],inputFileName,0,strlen(argv[1]));
    copySubString(argv[2],outputFileName,0,strlen(argv[2]));
    readFromInputfile();
    reflexive(F);
    symmetric(F);
    calculateWFRS(F,W,WFRS);
    calculateLFW(L,WFRS);
    for(int i=1;i<pow(2,UCount)-1;i++){
        generateSet(i,sets);
        generateSet(i,reverseSets);
        initialize(leftSet,1);
        for(int j = 0;j < UCount;j++){
            if(sets[j]==1){
                AND(leftSet,WFRS[j]);
            }
        }
        initialize(WrightSet,0);
        for(int j = 0;j < UCount;j++){
            if(sets[j]==1){
                OR(WrightSet,W[j]);
            }
        }
        RemoveOne(leftSet,WrightSet);
        for(int j=0;j<CCount;j++){
            if(leftSet[j]==1){
                for(int k=0;k<UCount;k++){
                    if(W[k][j]==1){
                        sets[k]=1;
                    }
                }
            }
        }
        if(!checkEqual(sets,reverseSets)&&!checkAllOnes(sets)){
        calculateDissimilarSets(sets,reverseSets);
        }
    }
    return 0;
}